.TH MORIA 6
.UC 4
.SH NAME
moria \- Dungeon Adventure
.SH SYNOPSIS
.B /usr/games/moria
[
.B \-ros
]
[
.I save_file
]
.SH DESCRIPTION
.PP
The game of
.I moria
is a single player dungeon simulation.   A
player  may  choose  from  a  number  of  races  and classes when
creating their character, and then 'run' that  character  over  a
period of days, weeks, even months; attempting to win the game by
defeating the Balrog which lurks in the deeper levels.
.PP
The player will begin his adventure on the town level  where
he  may  acquire supplies, weapons, armor, and magical devices by
bartering with various shop  owners.   After  preparing  for  his
adventure,  the  player  can  descend  into the dungeons of
.I moria
where fantastic adventures await his coming!
.PP
To get started you really only need to know two commands.  The command
.B ?
will give you a list of the available commands (below).
The
.B /
command will identify the objects you see on the screen.
Before beginning your first adventure, you should also read
.I The Dungeons of MORIA
document carefully.  The game of
.I moria
is a complicated game, and
will require a dedicated player to win.
.PP
The
.B \-r
switch will make the game accept rogue like commands.
.PP
The
.B \-o
switch will make the game accept original commands (this is the default).
.PP
The
.B \-s
switch will print the scores and then quit.
.PP
If
.I save_file
is specified,
.I moria
will be restored from the specified saved game file.
.SH "Original Mode Commands"
.nf
B <Dir> Bash (object/creature)|  q        Quaff a potion.
C       Display character.    |  r        Read a scroll.
D <Dir> Disarm a trap/chest.  |  s        Search for hidden doors.
E       Eat some food.        |  t        Take off an item.
F       Fill lamp with oil.   |  u        Use a staff.
L       Current location.     |  v        Version and credits.
P       Print map.            |  w        Wear/Wield an item.
R       Rest for a period.    |  x        Exchange weapon.
S       Search Mode.          |  /        Identify a character.
T <Dir> Tunnel.               |  ?        Display this panel.
a       Aim and fire a wand.  |
b       Browse a book.        |  ^P       Repeat the last message.
c <Dir> Close a door.         |  ^R       Redraw the screen.
d       Drop an item.         |  ^K       Quit the game.
e       Equipment list.       |  ^X       Save character and quit.
f       Fire/Throw an item.   |   $       Shell out of game.
i       Inventory list.       |  < Go up an up-staircase.
j <Dir> Jam a door with spike.|  > Go down a down-staircase
l <Dir> Look given direction. |  . <Dir>  Move in direction.
m       Cast a magic spell.   |  Movement: 7  8  9
o <Dir> Open a door/chest.    |            4     6    5 == Rest
p       Read a prayer.        |            1  2  3
.fi
.bp
.SH "Rogue Like Commands"
.nf
f <Dir> Bash (object/creature)|  q        Quaff a potion.
C       Display character.    |  r        Read a scroll.
D <Dir> Disarm a trap/chest.  |  s        Search for hidden doors.
E       Eat some food.        |  T        Take off an item.
F       Fill lamp with oil.   |  Z        Use a staff.
W       Current location.     |  v        Version and credits.
M       Print map.            |  w        Wear/Wield an item.
R       Rest for a period.    |  X        Exchange weapon.
#       Search Mode.          |  /        Identify a character.
CTRL <dir> Tunnel             |  ?        Display this panel.
z       Aim and fire a wand.  |
P       Browse a book.        |  ^P       Repeat the last message.
c <Dir> Close a door.         |  ^R       Redraw the screen.
d       Drop an item.         |  Q        Quit the game.
e       Equipment list.       |  ^X       Save character and quit.
t       Fire/Throw an item.   |   !       Shell out of game.
i       Inventory list.       |  < Go up an up-staircase.
S <Dir> Jam a door with spike.|  > Go down a down-staircase.
x <Dir> Look given direction. |  SHIFT <Dir>  Move in direction.
m       Cast a magic spell.   |  Movement: y  k  u
o <Dir> Open a door/chest.    |            h     l    . == Rest
p       Read a prayer.        |            b  j  n
.fi
.SH AUTHORS
Robert Alan Koeneke / University of Oklahoma
.br
Jimmey Wayne Todd   / University of Oklahoma
.SH UNIX Port
James E. Wilson     / UC Berkeley
.SH Manual Page
Roger S. Southwick  / Tektronix, Inc.
.SH BUGS
.PP
The SYS V version does not lock the scoreboard, if two processes try
to modify it at the same time, it may become corrupted.

Wearing an amulet or ring that would raise a stat over 18/100 actually only
raises the stat to 18/100.  When the amulet is removed, the stat drops to
a value below its original value.

Probably infinite (although countably infinite).
